﻿# Часто используемые команды в терминале Mac (Основы)

Переведено пользователем [vadeg](https://github.com/vadeg)

------------

_Большие буквы используются только для наглядности._  _Capslock должен быть выключен._
## Горячие клавиши

| Команда | Описание |
| ----------- | ----------- |
| Ctrl + A   | Переместиться в начало набранной строки.  Это также работает практически для всех полей ввода в системе, за исключением IDE Netbeans.|
| Ctrl + E   | Переместиться в конец выбранной строки.  Это также работает практически для всех полей ввода в системе, за исключением IDE Netbeans. |
| Ctrl + Q   | Очистить текушую строку |
| Ctrl + L   | Очистить экран |
| Cmd + K    | Очистить экран |
| Ctrl + U   | Вырезать все символы с начала строки и до текущего положения курсора |
| Ctrl + K   | Вырезать все символы начиная от текущего положения курсора и до конца строки |
| Ctrl + W   | Вырезать одно слово слева до первого пробела |
| Ctrl + Y   | Вставить то, что было вырезано последней командой "Вырезать" |
| Ctrl + H   | То же самое что клавиша Backspace |
| Ctrl + C   | Прервать исполнение запущенной программы |
| Ctrl + D   | Выход из консоли если в консоли нет запущенных процессов или послать EOF запущенному процессу |
| Ctrl + Z   | Переместить запущенный процесс в фоновый процесс и приостановать его. Команда `fg` восстанавливает прежнее состояние процесса. |
| Ctrl + _   | Отменить последнюю выполненную команду. (Это знак подчеркивания, т.е. Ctrl + Shift + minus) |
| Ctrl + T   | Поменять местами символ справа от курсора с символом слева от курсора. Если курсор находится в конце строки, то поменять последние два символа местами.|
| Ctrl + F   | Переместить курсор на один символ вперед |
| Ctrl + B   | Переместить курсор на один символ назад |
| Option + →  | Переместить курсор на одно слово вперед |
| Option + ←  | Переместить курсор на одно слово назад |
| Esc + T  | Поменять местами слово слева от курсора со словом справа от курсора. Если курсор стоит в конце строки, то поменять последние два слова местами.|
| Tab  | Автодополнение строки именами файлов или папок, которые совпадают с началом строки |

## КЛЮЧЕВЫЕ КОМАНДЫ

| Команда | Описание |
| ----------- | ----------- |
| cd [folder] | Сменить директорию. Например `cd Documents` |
| cd |  Переместиться в домашнюю директорию |
| cd ~ |  Переместиться в домашнюю директорию |
| cd /  | Переместиться в корневую папку диска |
| cd -  | Переместиться в предыдущую директорию |
| ls | Список файлов и папок в текущей директории |
| ls -l | Список файлов и папок в текущей директории. Название каждого файла/папки петатается на отдельно строке |
| ls -a | Список файлов и папок в текущей директории с учётом скрытых файлов и папок|
| ls -lh| Список файлов и папок с размером объектов в Кб, Мб и т.д. |
| ls -R | Отобразить рекурсивно список всех файлов и папок в директории |
| sudo [command] | Выполнить команду с правами суперпользователя (Super User DO) |
| open [file] | Открыть файл ( равносильно открытию файла двойным щелчком мыши ) |
| top | Отобразить активные процессы. Нажмите `q` для выхода |
| nano [file] | Открыть файл в редакторе `nano` |
| vim [file] | Открыть файл в редакторе `vim` |
| clear |  Очистить экран |
| reset |  Сбросить дисплей терминала |

## ОБЪЕДИНЕНИЕ КОМАНД В ЦЕПОЧКИ

| Команда | Описание |
| ----------- | ----------- |
| [command-a]; [command-b] | Выполнить команду `a`, а затем выполнить команду `b` независимо от результата выполнения команды `a`|
| [command-a] && [command-b] | Выполнить команду `b` только если команда `a` выполнилась успешно|
| [command-a] &#124;&#124; [command-b] | Выполнить команду `b` только если команда `a` выполнилась с ошибкой |
| [command-a] & | Выполнить команду `a` в фоновом режиме|


## ПЕРЕДАЧА РЕЗУЛЬТАТОВ ОДНОЙ КОМАНДЫ ДРУГОЙ КОМАНДЕ

| Команда | Описание |
| ----------- | ----------- |
| [command-a] \| [command-b] | Выполнить команду `a` и передать результат выполнения команде `b`. Например `ps auxwww \| grep google` |


## ИСТОРИЯ КОМАНД

| Команда | Описание |
| ----------- | ----------- |
| history n |  Показать последние набранные команды. Добавьте вместо `n` число чтобы ограничить количество команд |
| Ctrl + r  | Интерактивные поиск среди последних набранных команд |
| ![value] |  Выполнить последнюю набранную команду, которая начинается c ‘value’ |
| !! |  Выполнить последнюю набранную команду |

## РАБОТА С ФАЙЛАМИ

| Команда | Описание |
| ----------- | ----------- |
| touch [file] |   Создать новый файл |
| pwd | Отобразить полный путь текущей директории |
| . |  Текущая директория. Например `ls .` |
| .. | Родительская директория, Например `ls ..` |
| ls -l .. | Список всех файлов директорий, которые находятся на том же уровне что и родительская директория |
| cd ../../ | Переместиться на 2 уровня вверх |
| cat | Объединение и печать содержимого файлов |
| rm [file] |  Удалить файл. Например `rm data.tmp` |
| rm -i [file] | Удалить файл с подтверждением |
| rm -r [dir] | Удалить директорию и её содержимое |
| rm -f [file] | Удалить файл без подтверждения |
| cp [file] [newfile] | Копировать файл в другой файл |
| cp [file] [dir] | Копировать файл в директорию |
| mv [file] [new filename] |  Переместить/Переименовать файл. Например `mv file1.ad /tmp` |
| pbcopy < [file] | Копировать содержимое файла в буфер обмена |
| pbpaste | Вставить содержимое из буфера обмена |
| pbpaste > [file] | Вставить содержимое из буфера обмена в файл. Например `pbpaste > paste-test.txt` |

## РАБОТА С ДИРЕКТОРИЯМИ

| Команда | Описание |
| ----------- | ----------- |
| mkdir [dir] | Создать директорию |
| mkdir -p [dir]/[dir] |  Создать директорию и вложенную директорию |
| rmdir [dir] | Удалить директорию ( работает только с пустыми директориями ) |
| rm -R [dir] | Удалить директорию и содержимое |
| less [file]|  Вывести содержимое файла на экран. Прервать вывод если он не вмещается на экран. Можно продолжить вывод нажав `Space`  |
| [command] > [file] |  Поместить результат выполнения команды в файл. Существующий файл будет переписан с нуля |
| [command] >> [file] | Поместить результат выполнения команды в файл. Существующий файл будет дополненен |
| [command] < [file] |  Передать содержимое файла на вход команде |

## ПОИСК

| Команда | Описание |
| ----------- | ----------- |
| find [dir] -name [search_pattern] | Искать файлы в заданной директории. Например `find /Users -name "file.txt"` |
| grep [search_pattern] [file] | Искать строки в файле, которые подпадают под шаблон. Например `grep "Tom" file.txt` |
| grep -r [search_pattern] [dir] | Рекурсивно искать строки в файлах в заданной директории, которые подпадают под шаблон. |
| grep -v [search_pattern] [file] | Искать строки в файле, которые НЕ подпадают под шаблон |
| grep -i [search_pattern] [file] | Искать строки в файле, которые подпадают под шаблон с учётом регистра |
| mdfind [search_pattern] | Искать при помощи `Spotlight` (название, содержимое, другие данные). Например `mdfind skateboard` |
| mdfind -onlyin [dir] -name [pattern] | Искать при помощи `Spotlight` в заданной директории |

## ПОМОЩЬ

| Команда | Описание |
| ----------- | ----------- |
| [command] -h |  Вывод справки по команде|
| [command] --help | Вывод справки по команде |
| info [command] | Вывод справки по команде |
| man [command] |  Вывод руководства пользователя по команде [command] |
| whatis [command] | Вывод описания команды или команд подпадающих под шаблон [command] |
| apropos [search-pattern] | Поиск по базе данных команд по шаблону |
